#!/usr/bin/perl
#
# dcshop_admin.cgi
# DCShop Version 1.0 (10 Dec 1998)
# An Electronic Shopping Cart Program
# Copyright  1997-1998 DCScripts All Rights Reserved
#
# As part of the installation process, you will be asked
# to accept the terms of this Agreement. This Agreement is
# a legal contract, which specifies the terms of the license
# and warranty limitation between you and DCScripts and DCShop.
# You should carefully read the following terms and conditions before
# installing or using this software.  Unless you have a different license
# agreement obtained from DCScripts, installation or use of this software
# indicates your acceptance of the license and warranty limitation terms
# contained in this Agreement. If you do not agree to the terms of this
# Agreement, promptly delete and destroy all copies of the Software.
# 
# LICENSE TO REDISTRIBUTE
# Distributing the software and/or documentation with other products
# (commercial or otherwise) or by other than electronic means without
# DCScripts's prior written permission is forbidden.
# All rights to the DCShop software and documentation not expressly
# granted under this Agreement are reserved to DCScripts.
#
# DISCLAIMER OF WARRENTY
# THIS SOFTWARE AND ACCOMPANYING DOCUMENTATION ARE PROVIDED "AS IS" AND
# WITHOUT WARRANTIES AS TO PERFORMANCE OF MERCHANTABILITY OR ANY OTHER
# WARRANTIES WHETHER EXPRESSED OR IMPLIED.   BECAUSE OF THE VARIOUS HARDWARE
# AND SOFTWARE ENVIRONMENTS INTO WHICH DCSHOP MAY BE USED, NO WARRANTY OF
# FITNESS FOR A PARTICULAR PURPOSE IS OFFERED.  THE USER MUST ASSUME THE
# ENTIRE RISK OF USING THIS PROGRAM.  ANY LIABILITY OF DCSCRIPTS WILL BE
# LIMITED EXCLUSIVELY TO PRODUCT REPLACEMENT OR REFUND OF PURCHASE PRICE.
# IN NO CASE SHALL DCSCRIPTS BE LIABLE FOR ANY INCIDENTAL, SPECIAL OR
# CONSEQUENTIAL DAMAGES OR LOSS, INCLUDING, WITHOUT LIMITATION, LOST PROFITS
# OR THE INABILITY TO USE EQUIPMENT OR ACCESS DATA, WHETHER SUCH DAMAGES ARE
# BASED UPON A BREACH OF EXPRESS OR IMPLIED WARRANTIES, BREACH OF CONTRACT,
# NEGLIGENCE, STRICT TORT, OR ANY OTHER LEGAL THEORY. THIS IS TRUE EVEN IF
# DCSCRIPTS IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. IN NO CASE WILL
# DCSCRIPTS LIABILITY EXCEED THE AMOUNT OF THE LICENSE FEE ACTUALLY PAID
# BY LICENSEE TO DCSCRIPTS. 
#
###########################################################################
# Define directory path to your setup file.
# Use relative path if you can
# $path is directory path to where dcshop.cgi is

$path = "../../cgi-bin/DCShop";

# require setup file and cgi-lib library file
# Note "." for dcshop_admin.setup and dcprotect.pl

require "$path/dcshop.setup";
require "$path/dclib.pl";
require "$path/cgi-lib.pl";
require "./dcshop_admin.setup";
require "./dcprotect.pl";

#----DO NOT EDIT ANYTHING BELOW THIS LINE UNLESS YOU KNOW WHAT YOU'RE DOING---#

# Read in formdata
ReadParse();

print "Content-type: text/html\n";

$menu .= qq~
      [ <a href="$thisurl?az=login">/ħ</a> ]
      [ <a href="$thisurl"></a> ]
      [ <a href="$thisurl?action=view_orders">ֹ </a> ]
      [ <a href="$thisurl?dc_action=configure">ʱ⼳ ٲٱ</a> ]
~;

# Following line adds authentication

$r_userdata = dcprotect($thisurl,$password_file_dir,\%in,
         \@login_fields,\%field_form_type);

# Be sure to print the end of HTTP Header

print "\n";

if ($in{'action'} eq "view_orders") {

   unless ($in{'cart'}) {

   $header = $h_orders;
   $sub_header = $sh_orders;

      # get listing of orders from orders.txt file
      if (-e "$order_dir/$order_database") {

         my $r_orders = readdata("$order_dir/$order_database");
         my $fields = shift @{$r_orders};
         chomp($fields);
         my @fields = split(/\|/,$fields);
         my $j = -1;

         foreach (@fields) {
            $j++;
            $fields{$j} = $_;
         }

         $html_output .= qq~
         <table border="0" width="100%" cellspacing="1" cellpadding="4">
         <tr bgcolor="$bg_color{'1'}" align="left">
         <th>
         <font face="$font_face{'1'}" size="$font_size{'1'}"
         color="$font_color{'1'}"≯</font>
         </th>
         <th><font face="$font_face{'1'}" size="$font_size{'1'}"
         color="$font_color{'1'}">¥</font>
         </th>
         <th><font face="$font_face{'1'}" size="$font_size{'1'}"
         color="$font_color{'1'}">ֹȣ</font>
         </th>
         <th><font face="$font_face{'1'}" size="$font_size{'1'}"
         color="$font_color{'1'}">ֹ</font></th>
         </tr>
         ~;

         &toggle_color();
         foreach (@$r_orders) {
         &toggle_color();
            chomp;
            my @row = split /\|/;
            my $j = -1;
            foreach (@row) {
               $j++;
               $record{$fields{$j}} = $_;
            }
            $html_output .= qq~
            <tr>
            <td valign="top" align="left" bgcolor="$bgcolor"><font 
               size="$fontsize" face="$fontface"
               color="$fontcolor">$record{'꼭û ̸'}
               </a></font></td>
            <td valign="top" align="left"  bgcolor="$bgcolor"><font 
               size="$fontsize" face="$fontface"
               color="$fontcolor">
               $record{'Date'}</font></td>
            <td valign="top" align="left"  bgcolor="$bgcolor"><font 
               size="$fontsize" face="$fontface"
               color="$fontcolor"><a href="$adminscript?action=view_orders&cart=$record{'cart_id'}">
               $record{'cart_id'}</a></font></td>
            <td valign="top" align="left" bgcolor="$bgcolor"><font 
               size="$fontsize" face="$fontface"
               color="$fontcolor">$record{'Order Status'}</font></td>
            </tr>
            ~;
         }
         $html_output .= "</table>\n";       
      }
      else {
         opendir(D,"$order_dir") or my_die("Error opening $order_dir", $!);
         while ($file=readdir(D)) {
            if ($file =~ /(.*)\.cart$/) {
               push(@orders,$1);
            }
         }
         closedir(D);
         
         $html_output = "<ul>\n";
         foreach (@orders) {
            $html_output .= qq~
               <li><a href="$adminscript?action=view_orders&cart=$_">$_</a>
            ~;
         }
         $html_output .= "</ul>\n";
      }

   }
   else {

      $header = $h_order;
      $sub_header = $sh_order;

      $html_output .= display_order("$order_dir/$in{'cart'}.cart");
   }
}
elsif ($in{'action'} eq "update_order") {

   $header = $h_update;
   $sub_header = $sh_update;

   my $r_data = readdata("$order_dir/$order_database");

   my $j = -1;
   foreach (@{$r_data}) {
      @row = split /\|/;
      $j++;
      if ($row[1] eq "$in{'cart'}") {
         $row[-1] = "$in{'Order Status'}\n";
         $r_data->[$j] = join("\|",@row);
         last;
      }
   }

   writedata("$order_dir/$order_database",$r_data);

   $r_data = readdata("$order_dir/$in{'cart'}.cart");

   $j = -1;
   foreach (@{$r_data}) {
      $j++;
      if ($_ =~ /^Order Status=/) {
         $r_data->[$j] = "Order Status=$in{'Order Status'}\n";
         last;
      }  
   }

   writedata("$order_dir/$in{'cart'}.cart",$r_data);

   $html_output .= display_order("$order_dir/$in{'cart'}.cart");
}
else {

   $header = $h_main;
   $sub_header = $sh_main;

   $html_output .= qq~
   <ul>
      <li><a href="$thisurl?az=login">/ħ</a>
      <p>
      <li><a href="$adminscript?action=view_orders">ֹ </a>
      <li><a href="$adminscript?action=remove_orders">ֹ </a> -   .
      <li><a href="$adminscript?action=remove_carts"> īƮ </a> -   .
      <li><a href="$adminscript?action=update_database">ͺ̽ </a> -   .
      <p>
      <li><a href="$thisurl?dc_action=usermanage">ȸ </a>
      <li><a href="$thisurl?dc_action=configure">ʱ⼳ ٲٱ</a>
      <li><a href="$thisurl?dc_action=user_mod">ȸ ޴</a>
   </ul>
   ~;

}


my %namespace = (
    MENU => $menu,
    HEADER => $header,
    SUBHEADER => $sub_header,
    MENU => $menu,
    HTMLOUTPUT => $html_output );

display_output($templatefile,\%namespace); 

exit(0);

sub display_order {

   my ($cart) = shift;
   my (@order,%info);

   my $r_cartdata = readdata($cart);

   my $flag = '';
   foreach (@{$r_cartdata}) {
      chomp;
      $flag = 'on' unless ($_);
      unless ($flag) {
         push(@order,$_);
      }
      else {
         my ($key,$val) = split /=/;
         $info{$key} = $val;
      }
   }

   my $output .= qq~
   <table width="100%" border="0" cellspacing="1" cellpadding="3">
         <tr bgcolor="$bg_color{'1'}" align="right">        
         <th align="right" colspan="6"><font face="$font_face{1}"
         color="$font_color{1}" size="$font_size{1}">
         ֹȣ $in{cart}  ֹ 
         </font></th>
         </tr>
         <tr bgcolor="$bg_color{'1'}" align="right">        
         <td align="right" colspan="6"><font face="$font_face{1}"
         color="$font_color{1}" size="$font_size{1}">
         ֹ :
         <form method="post">
         <input type="hidden" name="action" value="update_order">       
         <input type="hidden" name="cart" value="$in{'cart'}">       
         <select name="Order Status">
         ~;

   foreach (@order_status) {
      if ($_ eq $info{'Order Status'}) {
         $output .= qq~
         <option value="$_" selected>$_
         ~;
      }
      else {
         $output .= qq~
         <option value="$_">$_
         ~;
      }
   }


   $output .= qq~
   </select>
   <input type="submit" value="">
   </form>
   </font></td>
   </tr>
   <tr bgcolor="$bg_color{'1'}" align="left">~;

   foreach (@cart_fields) {
      unless ($_ eq "ΰ") {
         $output .= qq~
         <th><font face="$font_face{1}"
            color="$font_color{1}" size="$font_size{1}">$_</font></th>
         ~;
      }
   }
   
   $output .= qq~
      <th><font face="$font_face{1}"
         color="$font_color{1}" size="$font_size{1}">հ</font></th>
   </tr>
   ~;

   toggle_color('reset');

   foreach (@order) {
      chomp;
      my @row = split /\|/;
      $output .= "<tr valign=\"top\" align=\"left\" bgcolor=\"$bgcolor\">\n";

      my $j = -1;
      my $taxable;

      foreach (@row) {

         $j++;
         if ($cart_fields[$j] eq "ID") {
            $id = $_;
            $output .= qq~
            <td align="right"><font
               size="$fontsize" face="$fontface" color="$fontcolor">
               $id</font>
            </td>~;
         }
         elsif ($cart_fields[$j] eq "") {
            $price = ($_);
            $output .= qq~
            <td align="right"><font
               size="$fontsize" face="$fontface" color="$fontcolor">
               \\$price</font>
            </td>~;
         }
         elsif ($cart_fields[$j] eq "") {
            $quantity = $_;
            $output .= qq~
            <td><font
               size="$fontsize" face="$fontface" 
               color="$fontcolor">$_</font>
            </td>~;
         }
         elsif ($cart_fields[$j] eq "ΰ") {
            $taxable = $_;
         }
         elsif ($cart_fields[$j] eq "ɼ") {
            $output .= qq~
            <td align="right"><font
               size="$fontsize" face="$fontface" color="$fontcolor">~;
            my (@options) = split /,/;
            foreach (@options) {
               my ($temp,$opt_price);
               my ($option,$choice) = split /=/;
               if ($choice =~ /::/) {
                  ($temp,$opt_price) = split(/::/,$choice);
                  $price += $opt_price;
                  $choice = $temp;
                  $output .= qq~
                     $option: $choice (+\\$opt_price)<br>~;
               }
               elsif ($_ eq "NA") {
                  $output .= qq~
                     &nbsp;~;
               }
               else {
                  $output .= qq~
                     $option: $choice<br>~;
               }
            }

            $output .= qq~
               </font>
            </td>~;
         }
         else {
            $output .= qq~
            <td>&nbsp;<font
               size="$fontsize" face="$fontface" color="$fontcolor">
               $_</font>
            </td>~;
         }
         
      }

      $sub_total = ($price * $quantity);

      if ($taxable) {
         $total_taxable += $sub_total;
      }
      else {
         $total_nontaxable += $sub_total;
      }

      $output .= qq~
      <td align="right"><font
         size="$fontsize" face="$fontface" color="$fontcolor">
         \\$sub_total</font>
      </td>
      </tr>~;

      toggle_color();

   }

   $total_nontaxable = ($total_nontaxable);
   $total_taxable = ($total_taxable);
   $total_tax = ($total_taxable*$sales_tax);
   $final = ($total_nontaxable + $total_taxable + $total_tax);

   $output .= qq~
   <tr>
      <td colspan="6" align="right"><hr size="1">$taxable</td></tr>
   <tr>
      <td colspan="4" align="right">&nbsp;</td>
      <th align="right" valign="top"><font
         size="$fontsize" face="$fontface" color="$fontcolor">
      հ (ΰ ):
      </font></th>
      <td align="right" valign="top"><font
         size="$fontsize" face="$fontface" 
         color="$fontcolor">\\$total_nontaxable</font></td></tr>
   <tr>
      <td colspan="4" align="right">&nbsp;</td>
      <th align="right" valign="top"><font
         size="$fontsize" face="$fontface" color="$fontcolor">
      հ (ΰ ):
      </font></th>
      <td align="right" valign="top"><font
         size="$fontsize" face="$fontface" 
         color="$fontcolor">\\$total_taxable</font></td></tr>
   <tr>
      <td colspan="4" align="right" valign="top">&nbsp;</td>
      <th align="right" valign="top"><font
         size="$fontsize" face="$fontface" color="$fontcolor">
      Ǹ :
      </font>
      </th>
      <td align="right"><font
         size="$fontsize" face="$fontface" 
         color="$fontcolor">\\$total_tax</font></td></tr>~;

   $shipping = ($shipping_method_price{$info{'Shipping Method'}} );
   $output .= qq~
   <tr>
   <td colspan="4" align="right">&nbsp;</td>
   <th align="right" valign="top"><font
      size="$fontsize" face="$fontface" color="$fontcolor">
   ǰ  ($info{'Shipping Method'}):
   </font>
   </th>
   <td align="right" valign="top">
   <input type="hidden" name="Shipping Method" value="$info{'Shipping Method'}">
   <font size="$fontsize" face="$fontface" 
      color="$fontcolor">\\$shipping</font></td></tr>~;
   $final += $shipping;

   $final = $final;
   $output .= qq~
   <tr>
      <td colspan="4" align="right">&nbsp;</td>
      <th align="right" valign="top"><font
         size="$fontsize" face="$fontface" color="$fontcolor">
       ǰ ֹ ݾ:
      </font>
      </th>
      <td align="right" valign="top"><font
         size="$fontsize" face="$fontface" 
         color="$fontcolor">\\$final</font></td></tr>
   <tr>
      <td colspan="6" align="right"><hr size="1"></td></tr>
   </table>
   ~;

   $output .= qq~
   <table width="100%" border="0" cellspacing="1" cellpadding="3">~;

   if ($order_forms{'Shipping Form'} eq "On") {

      $output .= qq~
      <tr bgcolor="$bg_color{'1'}" align="right">
      <th align="right" colspan="2"><font face="$font_face{1}"
      color="$font_color{1}" size="$font_size{1}">
      ǰ  ȳ
      </font></th></tr>~;

      toggle_color('reset');

      foreach (@shipping_form_fields) {
         $output .= qq~
         <tr valign="top" align="left">
         <th align="right" bgcolor="$bgcolor"><font
         size="$fontsize" face="$fontface" color="$fontcolor">
         $_:
         </font>
         </th>~;
         toggle_color();
         $output .= qq~
         <td align="left" bgcolor="$bgcolor">
         <font size="$fontsize" face="$fontface" color="$fontcolor">
         $info{$_}</font>
         </td></tr>
         ~;
         toggle_color();
      }
   }
   
   if ($order_forms{'Billing Form'} eq "On") {

      $output .= qq~
         <tr bgcolor="$bg_color{'1'}" align="right">        
         <th align="right" colspan="2"><font face="$font_face{1}"
         color="$font_color{1}" size="$font_size{1}">
         꼭   ȳ
         </font></th>
         </tr>
         ~;
      
      toggle_color('reset');
      foreach (@billing_form_fields) {
         $output .= qq~
         <tr valign="top" align="left">
         <th align="right" bgcolor="$bgcolor"><font
         size="$fontsize" face="$fontface" color="$fontcolor">
         $_:
         </font>
         </th>~;

         toggle_color();
         $output .= qq~
         <td align="left" bgcolor="$bgcolor">
         <font size="$fontsize" face="$fontface" color="$fontcolor">
         $info{$_}</font>
         </td>
         </tr>
         ~;
         toggle_color();
      }
   }

   if ($order_forms{'Credit Info Form'} eq "On") {

      $output .= qq~
         <tr bgcolor="$bg_color{'1'}" align="right">        
         <th align="right" colspan="2"><font face="$font_face{1}"
         color="$font_color{1}" size="$font_size{1}">
         ݰ  ȳ
         </font></th>
         </tr>
         ~;
      toggle_color('reset');

      foreach (@credit_form_fields) {
         $output .= qq~
         <tr valign="top" align="left">
         <th align="right" bgcolor="$bgcolor"><font
         size="$fontsize" face="$fontface" color="$fontcolor">
         $_:
         </font>
         </th>~;
         
         toggle_color();   
         $output .= qq~
         <td align="left" bgcolor="$bgcolor">
         <font size="$fontsize" face="$fontface" color="$fontcolor">
         $info{$_}</font>
         </td>
         </tr>
         ~;
         toggle_color();

      }

   }

   $output .= "</table>\n";

}